// -*- C++ -*-
/*!
 * @file  RT_Gesture_HouseControl.h
 * @brief Gesture_HouseControl
 * @date  $Date$
 *
 * $Id$
 */

#ifndef RT_GESTURE_HOUSECONTROL_H
#define RT_GESTURE_HOUSECONTROL_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>

#define KINECT_POSITION_X 50 //̒[_ƂƂKinecẗʒux[mm]
#define KINECT_POSITION_Y 1300 //̒[_ƂƂKinecẗʒuyiFj[mm]
#define KINECT_POSITION_Z 3820 //̒[_ƂƂKinecẗʒuziFsj[mm]
#define KINECT_POSITION_THETA 340 //Kinectݒupx@ɑ΂ĐAvɐ[deg]
#define KINECT_POSITION_ETA 0 //Kinectݒupx@ɑ΂ĐAvɐ[deg]

#define ROOM_X 4000 //X̋[mm]
#define ROOM_Y 2500 //Y̋[mm]
#define ROOM_Z 6700 //Z̋[mm]

#define PAI 3.141592 //pai
#define DEG315 5.497786 //315x
#define DEG270 4.71225 //270x
#define DEG160 2.792526 //160x
#define DEG200 3.4906577 //200x

#define OBJECT_NUM 1//Ɠdނ̐@P͎b
#define AudioVisual_1 0x00
#define AudioVisual_2 0x07
#define DigitalTelevision_1 0x01
#define DigitalTelevision_2 0x02
#define Power_1 0x00
#define Power_2 0x80
#define Toggle_1 0x00
#define Toggle_2 0x32

#define DigitalTelevisionID1_1 0x00
#define DigitalTelevisionID1_2 0x01
#define DigitalTelevisionID1_x1 0
#define DigitalTelevisionID1_x2 1400
#define DigitalTelevisionID1_z1 0
#define DigitalTelevisionID1_z2 500

// Service implementation headers
// <rtc-template block="service_impl_h">

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">

// </rtc-template>

using namespace RTC;

/*!
 * @class RT_Gesture_HouseControl
 * @brief Gesture_HouseControl
 *
 */
class RT_Gesture_HouseControl
  : public RTC::DataFlowComponentBase
{
 public:
  /*!
   * @brief constructor
   * @param manager Maneger Object
   */
  RT_Gesture_HouseControl(RTC::Manager* manager);

  /*!
   * @brief destructor
   */
  ~RT_Gesture_HouseControl();

  // <rtc-template block="public_attribute">
  
  // </rtc-template>

  // <rtc-template block="public_operation">
  
  // </rtc-template>

  /***
   *
   * The initialize action (on CREATED->ALIVE transition)
   * formaer rtc_init_entry() 
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onInitialize();

  /***
   *
   * The finalize action (on ALIVE->END transition)
   * formaer rtc_exiting_entry()
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onFinalize();

  /***
   *
   * The startup action when ExecutionContext startup
   * former rtc_starting_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);

  /***
   *
   * The shutdown action when ExecutionContext stop
   * former rtc_stopping_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);

  /***
   *
   * The activated action (Active state entry action)
   * former rtc_active_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

  /***
   *
   * The deactivated action (Active state exit action)
   * former rtc_active_exit()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

  /***
   *
   * The execution action that is invoked periodically
   * former rtc_active_do()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  /***
   *
   * The aborting action when main logic error occurred.
   * former rtc_aborting_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onAborting(RTC::UniqueId ec_id);

  /***
   *
   * The error action in ERROR state
   * former rtc_error_do()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onError(RTC::UniqueId ec_id);

  /***
   *
   * The reset action that is invoked resetting
   * This is same but different the former rtc_init_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onReset(RTC::UniqueId ec_id);
  
  /***
   *
   * The state update action that is invoked after onExecute() action
   * no corresponding operation exists in OpenRTm-aist-0.2.0
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onStateUpdate(RTC::UniqueId ec_id);

  /***
   *
   * The action that is invoked when execution context's rate is changed
   * no corresponding operation exists in OpenRTm-aist-0.2.0
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onRateChanged(RTC::UniqueId ec_id);


 protected:
  // <rtc-template block="protected_attribute">
  
  // </rtc-template>

  // <rtc-template block="protected_operation">
  
  // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  TimedPoint3D m_target_head;
  /*!
   */
  InPort<TimedPoint3D> m_target_headIn;
  TimedPoint3D m_target_neck;
  /*!
   */
  InPort<TimedPoint3D> m_target_neckIn;
  TimedPoint3D m_target_left_shoulder;
  /*!
   */
  InPort<TimedPoint3D> m_target_left_shoulderIn;
  TimedPoint3D m_target_left_elbow;
  /*!
   */
  InPort<TimedPoint3D> m_target_left_elbowIn;
  TimedPoint3D m_target_left_hand;
  /*!
   */
  InPort<TimedPoint3D> m_target_left_handIn;
  TimedPoint3D m_target_right_shoulder;
  /*!
   */
  InPort<TimedPoint3D> m_target_right_shoulderIn;
  TimedPoint3D m_target_right_elbow;
  /*!
   */
  InPort<TimedPoint3D> m_target_right_elbowIn;
  TimedPoint3D m_target_right_hand;
  /*!
   */
  InPort<TimedPoint3D> m_target_right_handIn;
  TimedString m_string_control;
  /*!
   */
  InPort<TimedString> m_string_controlIn;
  TimedUShort m_data_in_control;
  /*!
   */
  InPort<TimedUShort> m_data_in_controlIn;
  

  // </rtc-template>


  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  TimedString m_house_control;
  /*!
   */
  OutPort<TimedString> m_house_controlOut;
  TimedOctetSeq m_module_control;
  /*!
   */
  OutPort<TimedOctetSeq> m_module_controlOut;
  TimedString m_voice_control;
  /*!
   */
  OutPort<TimedString> m_voice_controlOut;
  TimedUShort m_add_control;
  /*!
   */
  OutPort<TimedUShort> m_add_controlOut;
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  
  // </rtc-template>

 private:
  // <rtc-template block="private_attribute">
  
  // </rtc-template>

  // <rtc-template block="private_operation">
  
  // </rtc-template>

};


extern "C"
{
  DLL_EXPORT void RT_Gesture_HouseControlInit(RTC::Manager* manager);
};

#endif // RT_GESTURE_HOUSECONTROL_H
